<?php
/********************************************************************************

    CodeBreak - Hidden Morse Code
    Version 1.2.1
    Copyright 2001-2019, Phillip Hullquist
    http://www.philliphullquist.com/scripts/codebreak/

    CodeBreak hides your secret message into a sentence that can be read using
    morse code as the key. After encoding your message, simply cover the upper
    or lower parts of the characters to reveal the hidden message.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

********************************************************************************/

include("functions.inc.php");
database_connect();

$input_text = strtoupper(trim($_POST["input_text"]));

if (empty($input_text)) {
    $output_text = "*** ENTER SOME TEXT TO ENCODE ***";
} else {
    if ($_POST["process_method"] == "encode" && $_POST["output_method"] == "text") {
        encode_letter_space();
        for ($cn = 0; $cn < strlen($input_text); $cn++) {
            switch ($input_text[$cn]) {
            case "A":
                encode_single_dot();
                encode_dash();
                break;
            case "B":
                encode_dash();
                encode_triple_dot();
                break;
            case "C":
                encode_dash();
                encode_single_dot();
                encode_dash();
                encode_single_dot();
                break;
            case "D":
                encode_dash();
                encode_double_dot();
                break;
            case "E":
                encode_single_dot();
                break;
            case "F":
                encode_double_dot();
                encode_dash();
                encode_single_dot();
                break;
            case "G":
                encode_dash();
                encode_dash();
                encode_single_dot();
                break;
            case "H":
                encode_triple_dot();
                encode_single_dot();
                break;
            case "I":
                encode_double_dot();
                break;
            case "J":
                encode_single_dot();
                encode_dash();
                encode_dash();
                encode_dash();
                break;
            case "K":
                encode_dash();
                encode_single_dot();
                encode_dash();
                break;
            case "L":
                encode_single_dot();
                encode_dash();
                encode_double_dot();
                break;
            case "M":
                encode_dash();
                encode_dash();
                break;
            case "N":
                encode_dash();
                encode_single_dot();
                break;
            case "O":
                encode_dash();
                encode_dash();
                encode_dash();
                break;
            case "P":
                encode_single_dot();
                encode_dash();
                encode_dash();
                encode_single_dot();
                break;
            case "Q":
                encode_dash();
                encode_dash();
                encode_single_dot();
                encode_dash();
                break;
            case "R":
                encode_single_dot();
                encode_dash();
                encode_single_dot();
                break;
            case "S":
                encode_triple_dot();
                break;
            case "T":
                encode_dash();
                break;
            case "U":
                encode_double_dot();
                encode_dash();
                break;
            case "V":
                encode_triple_dot();
                encode_dash();
                break;
            case "W":
                encode_single_dot();
                encode_dash();
                encode_dash();
                break;
            case "X":
                encode_dash();
                encode_double_dot();
                encode_dash();
                break;
            case "Y":
                encode_dash();
                encode_single_dot();
                encode_dash();
                encode_dash();
                break;
            case "Z":
                encode_dash();
                encode_dash();
                encode_double_dot();
                break;
            case "0":
                encode_dash();
                encode_dash();
                encode_dash();
                encode_dash();
                encode_dash();
                break;
            case "1":
                encode_single_dot();
                encode_dash();
                encode_dash();
                encode_dash();
                encode_dash();
                break;
            case "2":
                encode_double_dot();
                encode_dash();
                encode_dash();
                encode_dash();
                break;
            case "3":
                encode_triple_dot();
                encode_dash();
                encode_dash();
                break;
            case "4":
                encode_triple_dot();
                encode_single_dot();
                encode_dash();
                break;
            case "5":
                encode_triple_dot();
                encode_double_dot();
                break;
            case "6":
                encode_dash();
                encode_triple_dot();
                encode_single_dot();
                break;
            case "7":
                encode_dash();
                encode_dash();
                encode_triple_dot();
                break;
            case "8":
                encode_dash();
                encode_dash();
                encode_dash();
                encode_double_dot();
                break;
            case "9":
                encode_dash();
                encode_dash();
                encode_dash();
                encode_dash();
                encode_single_dot();
                break;
            case ".":
                encode_single_dot();
                encode_dash();
                encode_single_dot();
                encode_dash();
                encode_single_dot();
                encode_dash();
                break;
            case ",":
                encode_dash();
                encode_dash();
                encode_double_dot();
                encode_dash();
                encode_dash();
                break;
            case ":":
                encode_dash();
                encode_dash();
                encode_dash();
                encode_triple_dot();
                break;
            case "?":
                encode_double_dot();
                encode_dash();
                encode_dash();
                encode_double_dot();
                break;
            case "'":
                encode_single_dot();
                encode_dash();
                encode_dash();
                encode_dash();
                encode_dash();
                encode_single_dot();
                break;
            case "-":
                encode_dash();
                encode_triple_dot();
                encode_single_dot();
                encode_dash();
                break;
            case " ":
                encode_word_space();
                break;
            }  // end switch
            encode_letter_space();
            encode_letter_space();
        }  // end for
    } elseif ($_POST["process_method"] == "encode" && $_POST["output_method"] == "database") {
        for ($cn = 0; $cn < strlen($input_text); $cn++) {
            switch ($input_text[$cn]) {
            case "A":
                encode_morse(".-", $cn);
                break;
            case "B":
                encode_morse("-...", $cn);
                break;
            case "C":
                encode_morse("-.-.", $cn);
                break;
            case "D":
                encode_morse("-..", $cn);
                break;
            case "E":
                encode_morse(".", $cn);
                break;
            case "F":
                encode_morse("..-.", $cn);
                break;
            case "G":
                encode_morse("--.", $cn);
                break;
            case "H":
                encode_morse("....", $cn);
                break;
            case "I":
                encode_morse("..", $cn);
                break;
            case "J":
                encode_morse(".---", $cn);
                break;
            case "K":
                encode_morse("-.-", $cn);
                break;
            case "L":
                encode_morse(".-..", $cn);
                break;
            case "M":
                encode_morse("--", $cn);
                break;
            case "N":
                encode_morse("-.", $cn);
                break;
            case "O":
                encode_morse("---", $cn);
                break;
            case "P":
                encode_morse(".--.", $cn);
                break;
            case "Q":
                encode_morse("--.-", $cn);
                break;
            case "R":
                encode_morse(".-.", $cn);
                break;
            case "S":
                encode_morse("...", $cn);
                break;
            case "T":
                encode_morse("-", $cn);
                break;
            case "U":
                encode_morse("..-", $cn);
                break;
            case "V":
                encode_morse("...-", $cn);
                break;
            case "W":
                encode_morse(".--", $cn);
                break;
            case "X":
                encode_morse("-..-", $cn);
                break;
            case "Y":
                encode_morse("-.--", $cn);
                break;
            case "Z":
                encode_morse("--..", $cn);
                break;
            case "0":
                encode_morse("-----", $cn);
                break;
            case "1":
                encode_morse(".----", $cn);
                break;
            case "2":
                encode_morse("..---", $cn);
                break;
            case "3":
                encode_morse("...--", $cn);
                break;
            case "4":
                encode_morse("....-", $cn);
                break;
            case "5":
                encode_morse(".....", $cn);
                break;
            case "6":
                encode_morse("-....", $cn);
                break;
            case "7":
                encode_morse("--...", $cn);
                break;
            case "8":
                encode_morse("---..", $cn);
                break;
            case "9":
                encode_morse("----.", $cn);
                break;
            case ".":
                encode_morse(".-.-.-", $cn);
                break;
            case ",":
                encode_morse("--..--", $cn);
                break;
            case ":":
                encode_morse("---...", $cn);
                break;
            case "?":
                encode_morse("..--..", $cn);
                break;
            case "'":
                encode_morse(".----.", $cn);
                break;
            case "-":
                encode_morse("-....-", $cn);
                break;
            }  // end switch
        }  // end for
        $output_text = "<form>\n" . $output_text . "<br>\n<input type=\"submit\" name=\"action\" value=\"Select\">\n</form>\n";
    } elseif ($_POST["process_method"] == "decode" && $_POST["output_method"] == "text") {
        $output_text = str_replace("\r\n", "", $input_text);  // remove all newlines from string
        // check the first and last characters to ensure they match letter spaces
        $letter_space = array("B", "D", "P", "R");
        if (in_array($output_text[0], $letter_space) && in_array($output_text[strlen($output_text)-1], $letter_space)) {
            $search_characters_first = array("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z");
            if ($_POST["encode_method"] == "upper") {
                $replace_characters_first = array(".", "^", " ", "^", "-", "-", " ", "..", ".", ".", "..", ".", "..", "..", " ", "^", " ", "^", " ", "-", "..", "..", "...", "..", "..", "-");
            } elseif ($_POST["encode_method"] == "lower") {
                $replace_characters_first = array("..", "^", " ", "^", "-", ".", " ", "..", ".", " ", "..", "-", "...", "..", " ", ".", " ", "..", " ", ".", " ", ".", "..", "..", ".", "-");
            }
            $output_text = str_replace($search_characters_first, $replace_characters_first, $output_text);
            decode_morse();
        } else {
            $output_text = "*** INVALID ENTRY ***";
        }
    } elseif ($_POST["process_method"] == "decode" && $_POST["output_method"] == "database") {
        $working_words = explode(" ", $input_text);
        $num_elements = count($working_words);
        for ($idx = 0; $idx < $num_elements; ++$idx) {
            $result = mysqli_query($link, "SELECT code_" . $_POST["encode_method"] . " FROM dictionary WHERE words = '" . $working_words[$idx] . "'");
            if (($num_rows = mysqli_num_rows($result)) != 0) {
                while ($row = mysqli_fetch_row($result)) {
                    $output_text .= "^" . trim($row[0]) . "^";
                }
            } else {
                $output_text = "*** INVALID ENTRY ***";
                break;
            }
        }
        decode_morse();
    }
}

mysqli_close($link);
?>
<html>

<head>
  <title>CodeBreak - Hidden Morse Code</title>
</head>

<body>

<h2>CodeBreak - Hidden Morse Code</h2>

<form method="post" action="codebreak.php">
<table width="80%" border="0">
  <tr>
    <td width="50%" valign="top">
      <h3>Input</h3>
      <textarea name="input_text" rows="10" cols="40">
<?php echo(stripslashes($input_text)); ?></textarea><br>
      <select name="process_method">
        <option value="encode"<?php if ($_POST["process_method"] == "encode") echo(" selected"); ?>>Encode</option>
        <option value="decode"<?php if ($_POST["process_method"] == "decode") echo(" selected"); ?>>Decode</option>
      </select>
      <select name="encode_method">
        <option value="upper"<?php if ($_POST["encode_method"] == "upper") echo(" selected"); ?>>Upper</option>
        <option value="lower"<?php if ($_POST["encode_method"] == "lower") echo(" selected"); ?>>Lower</option>
      </select>
      <select name="output_method">
<?php if ($option_database): ?>
        <option value="database"<?php if ($_POST["output_method"] == "database") echo(" selected"); ?>>Database</option>
<?php endif; ?>
        <option value="text"<?php if ($_POST["output_method"] == "text") echo(" selected"); ?>>Text</option>
      </select>
      <input type="submit" value="Process Input">
    </td>
    <td width="50%" valign="top">
      <h3>Output</h3>
<?php if ($_POST["process_method"] == "encode" && $_POST["output_method"] == "database"): ?>
<?php echo($output_text); ?>
<?php else: ?>
      <textarea rows="10" cols="40" readonly>
<?php echo($output_text); ?></textarea><br>
<?php endif; ?>
    </td>
  </tr>
</table>
</form>
<?php
if ($_POST["action"] == "Select") {
    $working_text = implode(" ", array_slice($_POST, 4, -1));  // combine array items and remove unwanted variables
    $working_text = strtoupper($working_text);
    echo("\n<hr>\n");
    for ($cn = 0; $cn < strlen($working_text); $cn++) {
        $box_gothic = substr($working_text, $cn, 1);
        if (ctype_alnum($box_gothic)) {
            echo("<img src=\"box_gothic/" . $box_gothic . ".png\" height=\"50\">");
        } else {
            echo("&nbsp;\n");
        }
    }
    echo("\n<hr>\n");
    echo($working_text);
    echo("\n<hr>\n");
}
?>

<p><b>About CodeBreak:</b> CodeBreak hides your secret message into a sentence that can be read using morse code as the key. After encoding your message, simply cover the upper or lower parts of the characters to reveal the hidden message.</p>
<p><b>Encoding Instructions:</b> CodeBreak will only encode alpha-numerical and the following characters: space, period, comma, colon, question mark, apostrophe, hyphen. All other characters will be ignored. Upper and Lower choose if you want to hide the code on the top or bottom of each letter. The database option lets you match the results against a database of words to try and make the encoded message readable.</p>
<p><b>Decoding Instructions:</b> Change the method to 'Decode' and choose the options that the message was originally encoded in. Enter the code into the 'Input' box and click on 'Process'. The decoded message will appear in the 'Output' box.</p>

<p><i>Copyright &copy; 2001 <a href="http://www.philliphullquist.com/">Phillip Hullquist</a></i></p>

</body>

</html>
